# coding: utf-8

"""
Copyright 2016 SmartBear Software

    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at

        http://www.apache.org/licenses/LICENSE-2.0

    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.

    Ref: https://github.com/swagger-api/swagger-codegen
"""

from pprint import pformat
from six import iteritems
import re


class AnalyticsSurvey(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        AnalyticsSurvey - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'survey_id': 'str',
            'survey_form_id': 'str',
            'survey_form_context_id': 'str',
            'participant_id': 'str',
            'external_contact_id': 'str',
            'customer_address': 'str',
            'user_id': 'str',
            'queue_id': 'str',
            'status': 'str',
            'created_date': 'datetime'
        }

        self.attribute_map = {
            'survey_id': 'surveyId',
            'survey_form_id': 'surveyFormId',
            'survey_form_context_id': 'surveyFormContextId',
            'participant_id': 'participantId',
            'external_contact_id': 'externalContactId',
            'customer_address': 'customerAddress',
            'user_id': 'userId',
            'queue_id': 'queueId',
            'status': 'status',
            'created_date': 'createdDate'
        }

        self._survey_id = None
        self._survey_form_id = None
        self._survey_form_context_id = None
        self._participant_id = None
        self._external_contact_id = None
        self._customer_address = None
        self._user_id = None
        self._queue_id = None
        self._status = None
        self._created_date = None

    @property
    def survey_id(self):
        """
        Gets the survey_id of this AnalyticsSurvey.
        Unique identifier for the survey

        :return: The survey_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._survey_id

    @survey_id.setter
    def survey_id(self, survey_id):
        """
        Sets the survey_id of this AnalyticsSurvey.
        Unique identifier for the survey

        :param survey_id: The survey_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._survey_id = survey_id

    @property
    def survey_form_id(self):
        """
        Gets the survey_form_id of this AnalyticsSurvey.
        Unique identifier for the survey form

        :return: The survey_form_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._survey_form_id

    @survey_form_id.setter
    def survey_form_id(self, survey_form_id):
        """
        Sets the survey_form_id of this AnalyticsSurvey.
        Unique identifier for the survey form

        :param survey_form_id: The survey_form_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._survey_form_id = survey_form_id

    @property
    def survey_form_context_id(self):
        """
        Gets the survey_form_context_id of this AnalyticsSurvey.
        Unique identifier for the survey form, regardless of version

        :return: The survey_form_context_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._survey_form_context_id

    @survey_form_context_id.setter
    def survey_form_context_id(self, survey_form_context_id):
        """
        Sets the survey_form_context_id of this AnalyticsSurvey.
        Unique identifier for the survey form, regardless of version

        :param survey_form_context_id: The survey_form_context_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._survey_form_context_id = survey_form_context_id

    @property
    def participant_id(self):
        """
        Gets the participant_id of this AnalyticsSurvey.
        Unique identifier of participant

        :return: The participant_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._participant_id

    @participant_id.setter
    def participant_id(self, participant_id):
        """
        Sets the participant_id of this AnalyticsSurvey.
        Unique identifier of participant

        :param participant_id: The participant_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._participant_id = participant_id

    @property
    def external_contact_id(self):
        """
        Gets the external_contact_id of this AnalyticsSurvey.
        External contact id

        :return: The external_contact_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._external_contact_id

    @external_contact_id.setter
    def external_contact_id(self, external_contact_id):
        """
        Sets the external_contact_id of this AnalyticsSurvey.
        External contact id

        :param external_contact_id: The external_contact_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._external_contact_id = external_contact_id

    @property
    def customer_address(self):
        """
        Gets the customer_address of this AnalyticsSurvey.
        Customer address

        :return: The customer_address of this AnalyticsSurvey.
        :rtype: str
        """
        return self._customer_address

    @customer_address.setter
    def customer_address(self, customer_address):
        """
        Sets the customer_address of this AnalyticsSurvey.
        Customer address

        :param customer_address: The customer_address of this AnalyticsSurvey.
        :type: str
        """
        
        self._customer_address = customer_address

    @property
    def user_id(self):
        """
        Gets the user_id of this AnalyticsSurvey.
        A unique identifier of the PureCloud user

        :return: The user_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._user_id

    @user_id.setter
    def user_id(self, user_id):
        """
        Sets the user_id of this AnalyticsSurvey.
        A unique identifier of the PureCloud user

        :param user_id: The user_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._user_id = user_id

    @property
    def queue_id(self):
        """
        Gets the queue_id of this AnalyticsSurvey.
        Unique identifier for the queue the conversation was on

        :return: The queue_id of this AnalyticsSurvey.
        :rtype: str
        """
        return self._queue_id

    @queue_id.setter
    def queue_id(self, queue_id):
        """
        Sets the queue_id of this AnalyticsSurvey.
        Unique identifier for the queue the conversation was on

        :param queue_id: The queue_id of this AnalyticsSurvey.
        :type: str
        """
        
        self._queue_id = queue_id

    @property
    def status(self):
        """
        Gets the status of this AnalyticsSurvey.
        Survey status

        :return: The status of this AnalyticsSurvey.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this AnalyticsSurvey.
        Survey status

        :param status: The status of this AnalyticsSurvey.
        :type: str
        """
        
        self._status = status

    @property
    def created_date(self):
        """
        Gets the created_date of this AnalyticsSurvey.
        Creation date of survey. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ

        :return: The created_date of this AnalyticsSurvey.
        :rtype: datetime
        """
        return self._created_date

    @created_date.setter
    def created_date(self, created_date):
        """
        Sets the created_date of this AnalyticsSurvey.
        Creation date of survey. Date time is represented as an ISO-8601 string. For example: yyyy-MM-ddTHH:mm:ss.SSSZ

        :param created_date: The created_date of this AnalyticsSurvey.
        :type: datetime
        """
        
        self._created_date = created_date

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

